module Funcons.Core.Manual (
    Funcons.Core.Manual.library
    , module Funcons.Core.Computations.DataFlow.Generating.AtomSeed 
    , module Funcons.Core.Computations.DataFlow.Generating.NextAtom 
    , module Funcons.Core.Values.Composite.Collections.Sets 
    , module Funcons.Core.Values.Composite.Collections.Multisets 
    , module Funcons.Core.Values.Composite.Collections.Lists 
    , module Funcons.Core.Values.Composite.Collections.Maps 
    , module Funcons.Core.Values.Composite.Collections.Vectors 
    , module Funcons.Core.Values.Composite.AlgebraicDatatypeValues.AlgebraicDatatypes 
    , module Funcons.Core.Values.Primitive.StringsBuiltin 
    , module Funcons.Core.Values.Primitive.BitsBuiltin 
    , module Funcons.Core.Values.Primitive.Numbers.Integers 
    , module Funcons.Core.Values.Primitive.Numbers.IeeeFloatsBuiltin 
    , module Funcons.Core.Values.Primitive.Numbers.RationalsBuiltin 
    , module Funcons.Core.Values.Primitive.Atoms 
    , module Funcons.Core.Values.Primitive.Characters 
    , module Funcons.Core.Abstractions.Thunk 
    , module Funcons.Core.Abstractions.Force 
    , module Funcons.Core.Values.Composite.Collections.TuplesBuiltin 
    )where
import Funcons.EDSL

import Funcons.Core.Computations.DataFlow.Generating.AtomSeed hiding (library)
import Funcons.Core.Computations.DataFlow.Generating.NextAtom hiding (library)
import Funcons.Core.Values.Composite.Collections.Sets hiding (library)
import Funcons.Core.Values.Composite.Collections.Multisets hiding (library)
import Funcons.Core.Values.Composite.Collections.Lists hiding (library)
import Funcons.Core.Values.Composite.Collections.Maps hiding (library)
import Funcons.Core.Values.Composite.Collections.Vectors hiding (library)
import Funcons.Core.Values.Composite.AlgebraicDatatypeValues.AlgebraicDatatypes hiding (library)
import Funcons.Core.Values.Primitive.StringsBuiltin hiding (library)
import Funcons.Core.Values.Primitive.BitsBuiltin hiding (library)
import Funcons.Core.Values.Primitive.Numbers.Integers hiding (library)
import Funcons.Core.Values.Primitive.Numbers.IeeeFloatsBuiltin hiding (library)
import Funcons.Core.Values.Primitive.Numbers.RationalsBuiltin hiding (library)
import Funcons.Core.Values.Primitive.Atoms hiding (library)
import Funcons.Core.Values.Primitive.Characters hiding (library)
import Funcons.Core.Abstractions.Thunk hiding (library)
import Funcons.Core.Abstractions.Force hiding (library)
import Funcons.Core.Values.Composite.Collections.TuplesBuiltin hiding (library)

import qualified Funcons.Core.Computations.DataFlow.Generating.AtomSeed
import qualified Funcons.Core.Computations.DataFlow.Generating.NextAtom
import qualified Funcons.Core.Values.Composite.Collections.Sets
import qualified Funcons.Core.Values.Composite.Collections.Multisets
import qualified Funcons.Core.Values.Composite.Collections.Lists
import qualified Funcons.Core.Values.Composite.Collections.Maps
import qualified Funcons.Core.Values.Composite.Collections.Vectors
import qualified Funcons.Core.Values.Composite.AlgebraicDatatypeValues.AlgebraicDatatypes
import qualified Funcons.Core.Values.Primitive.StringsBuiltin
import qualified Funcons.Core.Values.Primitive.BitsBuiltin
import qualified Funcons.Core.Values.Primitive.Numbers.Integers
import qualified Funcons.Core.Values.Primitive.Numbers.IeeeFloatsBuiltin
import qualified Funcons.Core.Values.Primitive.Numbers.RationalsBuiltin
import qualified Funcons.Core.Values.Primitive.Atoms
import qualified Funcons.Core.Values.Primitive.Characters
import qualified Funcons.Core.Abstractions.Thunk
import qualified Funcons.Core.Abstractions.Force
import qualified Funcons.Core.Values.Composite.Collections.TuplesBuiltin

library = libUnions
    [
    Funcons.Core.Computations.DataFlow.Generating.AtomSeed.library
    , Funcons.Core.Computations.DataFlow.Generating.NextAtom.library
    , Funcons.Core.Values.Composite.Collections.Sets.library
    , Funcons.Core.Values.Composite.Collections.Multisets.library
    , Funcons.Core.Values.Composite.Collections.Lists.library
    , Funcons.Core.Values.Composite.Collections.Maps.library
    , Funcons.Core.Values.Composite.Collections.Vectors.library
    , Funcons.Core.Values.Composite.AlgebraicDatatypeValues.AlgebraicDatatypes.library
    , Funcons.Core.Values.Primitive.StringsBuiltin.library
    , Funcons.Core.Values.Primitive.BitsBuiltin.library
    , Funcons.Core.Values.Primitive.Numbers.Integers.library
    , Funcons.Core.Values.Primitive.Numbers.IeeeFloatsBuiltin.library
    , Funcons.Core.Values.Primitive.Numbers.RationalsBuiltin.library
    , Funcons.Core.Values.Primitive.Atoms.library
    , Funcons.Core.Values.Primitive.Characters.library
    , Funcons.Core.Abstractions.Thunk.library
    , Funcons.Core.Abstractions.Force.library
    , Funcons.Core.Values.Composite.Collections.TuplesBuiltin.library
    ]
